;
; PROTOTYPES
;
DDClear                  PROTO :LPDIRECTDRAWSURFACE,:DWORD,:DWORD,:DWORD,:DWORD
DDPutPixel               PROTO :LPDIRECTDRAWSURFACE,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
CreateRGB                PROTO :DWORD,:DWORD,:DWORD
DirectDrawInit           PROTO :HWND
CreateDirectDrawSurfaces PROTO :BOOL
DestroyDirectDrawObjects PROTO
CheckSurfaces            PROTO
DDFlip                   PROTO
DrawScene                PROTO

;
; MACROS
;
CHECK_DD MACRO
    .if eax!=DD_OK
        mov eax,FALSE
        ret
    .endif
endm

MakeRGB MACRO r,g,b       
    m_x = ((r/8) shl 11) or ((g/4) shl 5) or (b/8)
    mov eax,m_x
    exitm <eax>
endm

;
; DEFINES
;
INIT_HEIGHT = 216
INIT_WIDTH  = 250
STRETCHX    = 18
STRETCHY    = 7

;
; INTIALIZED / UNINTIALIZED DATA
;
 
.data
g_bFullScreen BOOL TRUE
g_iBpp        dd   0 

.data?

g_pDD      LPDIRECTDRAW        ? ; DirectDraw Object 
g_pClipper LPDIRECTDRAWCLIPPER ? ; Clipper 
g_pDDS     LPDIRECTDRAWSURFACE ? ; Primary Surface
g_pDDSBack LPDIRECTDRAWSURFACE ? ; Buffer Surface
;ddsd       DDSURFACEDESC       <?>
g_hWnd     HWND                ? ; Global HWND