
DirectInputInit proc hInst:HINSTANCE
    
    ;Create InputDevice COM Object
    invoke DirectInput8Create,hInst,\
                  DIRECTINPUT_VERSION,\
                  offset IID_IDirectInput8,\
                  offset InputDevice,NULL
                  
    CHECK_DDI    
    mov eax,TRUE                 
    ret

DirectInputInit endp

CreateDirectInputDevice proc hWnd:HWND
    
    DIINVOKE CreateDevice,InputDevice,OFFSET GUID_SysKeyboard,OFFSET m_keyboard,NULL
    CHECK_DDI

    DIDINVOKE  SetDataFormat,m_keyboard,addr c_dfDIKeyboard
    CHECK_DDI
    
    DIDINVOKE  SetCooperativeLevel,m_keyboard,hWnd,DISCL_BACKGROUND or DISCL_NONEXCLUSIVE
    CHECK_DDI

    DIDINVOKE  Acquire,m_keyboard
    CHECK_DDI

    mov eax,TRUE
    ret
CreateDirectInputDevice endp    

;
; Release the DirectInput Objects
;
DestroyDirectInputDevices proc
    
    .if (m_keyboard!=NULL)
        DIDINVOKE Release,m_keyboard
    .endif
    
    .if (InputDevice!=NULL)
        DIINVOKE Release,InputDevice
    .endif
    
    ret

DestroyDirectInputDevices endp